diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-information-element.cc ns-3.39/src/wifi/model/wifi-information-element.cc
--- ns-3.38/src/wifi/model/wifi-information-element.cc	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/wifi-information-element.cc	2023-07-05 14:23:48.121428500 -0700
@@ -238,27 +238,34 @@
         return false;
     }
 
-    if (GetInformationFieldSize() != a.GetInformationFieldSize())
+    if (ElementIdExt() != a.ElementIdExt())
     {
         return false;
     }
 
-    if (ElementIdExt() != a.ElementIdExt())
+    uint32_t ieSize = GetSerializedSize();
+
+    if (ieSize != a.GetSerializedSize())
     {
         return false;
     }
 
-    uint32_t ieSize = GetInformationFieldSize();
-
     Buffer myIe;
     Buffer hisIe;
     myIe.AddAtEnd(ieSize);
     hisIe.AddAtEnd(ieSize);
 
-    SerializeInformationField(myIe.Begin());
-    a.SerializeInformationField(hisIe.Begin());
+    Serialize(myIe.Begin());
+    a.Serialize(hisIe.Begin());
 
     return (memcmp(myIe.PeekData(), hisIe.PeekData(), ieSize) == 0);
 }
 
+std::ostream&
+operator<<(std::ostream& os, const WifiInformationElement& element)
+{
+    element.Print(os);
+    return os;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-information-element.h ns-3.39/src/wifi/model/wifi-information-element.h
--- ns-3.38/src/wifi/model/wifi-information-element.h	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/wifi-information-element.h	2023-07-05 14:23:48.121428500 -0700
@@ -199,7 +199,7 @@
 #define IE_CLUSTER_REPORT ((WifiInformationElementId)166)
 #define IE_RELAY_CAPABILITIES ((WifiInformationElementId)167)
 #define IE_RELAY_TRANSFER_PARAMETER_SET ((WifiInformationElementId)168)
-#define IE_BEAMLINK_MAINENANCE ((WifiInformationElementId)169)
+#define IE_BEAMLINK_MAINTENANCE ((WifiInformationElementId)169)
 // 170 to 171 are reserved
 #define IE_DMG_LINK_ADAPTATION_ACKNOWLEDGMENT ((WifiInformationElementId)172)
 // 173 is reserved
@@ -233,6 +233,8 @@
 #define IE_EXT_UORA_PARAMETER_SET ((WifiInformationElementId)37)
 #define IE_EXT_MU_EDCA_PARAMETER_SET ((WifiInformationElementId)38)
 
+#define IE_EXT_NON_INHERITANCE ((WifiInformationElementId)56)
+
 #define IE_EXT_EHT_OPERATION ((WifiInformationElementId)106)
 #define IE_EXT_MULTI_LINK_ELEMENT ((WifiInformationElementId)107)
 #define IE_EXT_EHT_CAPABILITIES ((WifiInformationElementId)108)
@@ -306,25 +308,17 @@
      */
     Buffer::Iterator Deserialize(Buffer::Iterator i);
     /**
-     * Deserialize an entire IE (which may possibly be fragmented into multiple
-     * elements) that is optionally present. The iterator passed in
+     * Deserialize entire IE (which may possibly be fragmented into multiple
+     * elements) if it is present. The iterator passed in
      * must be pointing at the Element ID of an information element. If
-     * the Element ID is not the requested one, the same iterator will
-     * be returned. Otherwise, an iterator pointing to the octet after
-     * the end of the information element is returned.
-     *
-     * \tparam IE \deduced Information Element type
-     * \tparam Args \deduced type of the arguments to forward to the constructor of the IE
-     * \param[out] optElem an object that contains the information element, if present
-     * \param i an iterator which points to where the IE should be read
-     * \param args arguments to forward to the constructor of the IE.
-     * \return the input iterator, if the requested IE is not present, or an iterator
-     *         pointing to the octet after the end of the information element, otherwise
-     */
-    template <typename IE, typename... Args>
-    static Buffer::Iterator DeserializeIfPresent(std::optional<IE>& optElem,
-                                                 Buffer::Iterator i,
-                                                 Args&&... args);
+     * the Element ID is not the one that the given class is interested
+     * in then it will return the same iterator.
+     *
+     * \param i an iterator which points to where the IE should be read.
+     *
+     * \return an iterator
+     */
+    Buffer::Iterator DeserializeIfPresent(Buffer::Iterator i);
     /**
      * Get the size of the serialized IE including Element ID and
      * length fields (for every element this IE is possibly fragmented into).
@@ -366,18 +360,6 @@
 
   private:
     /**
-     * Deserialize entire IE (which may possibly be fragmented into multiple
-     * elements) if it is present. The iterator passed in
-     * must be pointing at the Element ID of an information element. If
-     * the Element ID is not the one that the given class is interested
-     * in then it will return the same iterator.
-     *
-     * \param i an iterator which points to where the IE should be read.
-     *
-     * \return an iterator
-     */
-    Buffer::Iterator DeserializeIfPresent(Buffer::Iterator i);
-    /**
      * Serialize an IE that needs to be fragmented.
      *
      * \param i an iterator which points to where the IE should be written.
@@ -423,35 +405,14 @@
     virtual uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) = 0;
 };
 
-} // namespace ns3
-
-/***************************************************************
- *  Implementation of the templates declared above.
- ***************************************************************/
-
-namespace ns3
-{
-
-template <typename IE, typename... Args>
-Buffer::Iterator
-WifiInformationElement::DeserializeIfPresent(std::optional<IE>& optElem,
-                                             Buffer::Iterator i,
-                                             Args&&... args)
-{
-    optElem = std::nullopt;
-    IE elem(std::forward<Args>(args)...);
-
-    Buffer::Iterator start = i;
-    i = elem.DeserializeIfPresent(i);
-
-    if (i.GetDistanceFrom(start) != 0)
-    {
-        // the element is present and has been deserialized
-        optElem = elem;
-    }
-
-    return i;
-}
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the output stream
+ * \param element the Information Element
+ * \returns a reference to the stream
+ */
+std::ostream& operator<<(std::ostream& os, const WifiInformationElement& element);
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-mac.cc ns-3.39/src/wifi/model/wifi-mac.cc
--- ns-3.38/src/wifi/model/wifi-mac.cc	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-mac.cc	2023-07-05 14:23:48.121428500 -0700
@@ -26,7 +26,6 @@
 #include "mgt-headers.h"
 #include "qos-txop.h"
 #include "ssid.h"
-#include "wifi-mac-queue-scheduler.h"
 #include "wifi-mac-queue.h"
 #include "wifi-net-device.h"
 
@@ -363,6 +362,14 @@
     {
         it->second->Initialize();
     }
+
+    for (auto& link : m_links)
+    {
+        if (auto cam = link->channelAccessManager)
+        {
+            cam->Initialize();
+        }
+    }
 }
 
 void
@@ -539,6 +546,23 @@
     return (txop ? txop->GetWifiMacQueue() : nullptr);
 }
 
+bool
+WifiMac::HasFramesToTransmit(uint8_t linkId)
+{
+    if (m_txop && m_txop->HasFramesToTransmit(linkId))
+    {
+        return true;
+    }
+    for (const auto& [aci, qosTxop] : m_edca)
+    {
+        if (qosTxop->HasFramesToTransmit(linkId))
+        {
+            return true;
+        }
+    }
+    return false;
+}
+
 void
 WifiMac::SetMacQueueScheduler(Ptr<WifiMacQueueScheduler> scheduler)
 {
@@ -1086,6 +1110,98 @@
 }
 
 void
+WifiMac::BlockUnicastTxOnLinks(WifiQueueBlockedReason reason,
+                               const Mac48Address& address,
+                               const std::set<uint8_t>& linkIds)
+{
+    NS_LOG_FUNCTION(this << reason << address);
+    NS_ASSERT(m_scheduler);
+
+    for (const auto linkId : linkIds)
+    {
+        auto& link = GetLink(linkId);
+        auto linkAddr = link.stationManager->GetAffiliatedStaAddress(address).value_or(address);
+
+        if (link.stationManager->GetMldAddress(address) == address && linkAddr == address)
+        {
+            NS_LOG_DEBUG("Link " << +linkId << " has not been setup with the MLD, skip");
+            continue;
+        }
+
+        for (const auto [acIndex, ac] : wifiAcList)
+        {
+            // block queues storing QoS data frames and control frames that use MLD addresses
+            m_scheduler->BlockQueues(reason,
+                                     acIndex,
+                                     {WIFI_QOSDATA_QUEUE, WIFI_CTL_QUEUE},
+                                     address,
+                                     GetAddress(),
+                                     {ac.GetLowTid(), ac.GetHighTid()},
+                                     {linkId});
+            // block queues storing management and control frames that use link addresses
+            m_scheduler->BlockQueues(reason,
+                                     acIndex,
+                                     {WIFI_MGT_QUEUE, WIFI_CTL_QUEUE},
+                                     linkAddr,
+                                     link.feManager->GetAddress(),
+                                     {},
+                                     {linkId});
+        }
+    }
+}
+
+void
+WifiMac::UnblockUnicastTxOnLinks(WifiQueueBlockedReason reason,
+                                 const Mac48Address& address,
+                                 const std::set<uint8_t>& linkIds)
+{
+    NS_LOG_FUNCTION(this << reason << address);
+    NS_ASSERT(m_scheduler);
+
+    for (const auto linkId : linkIds)
+    {
+        auto& link = GetLink(linkId);
+        auto linkAddr = link.stationManager->GetAffiliatedStaAddress(address).value_or(address);
+
+        if (link.stationManager->GetMldAddress(address) == address && linkAddr == address)
+        {
+            NS_LOG_DEBUG("Link " << +linkId << " has not been setup with the MLD, skip");
+            continue;
+        }
+
+        for (const auto [acIndex, ac] : wifiAcList)
+        {
+            // unblock queues storing QoS data frames and control frames that use MLD addresses
+            m_scheduler->UnblockQueues(reason,
+                                       acIndex,
+                                       {WIFI_QOSDATA_QUEUE, WIFI_CTL_QUEUE},
+                                       address,
+                                       GetAddress(),
+                                       {ac.GetLowTid(), ac.GetHighTid()},
+                                       {linkId});
+            // unblock queues storing management and control frames that use link addresses
+            m_scheduler->UnblockQueues(reason,
+                                       acIndex,
+                                       {WIFI_MGT_QUEUE, WIFI_CTL_QUEUE},
+                                       linkAddr,
+                                       link.feManager->GetAddress(),
+                                       {},
+                                       {linkId});
+            // request channel access if needed (schedule now because multiple invocations
+            // of this method may be done in a loop at the caller)
+            auto qosTxop = GetQosTxop(acIndex);
+            Simulator::ScheduleNow([=]() {
+                if (qosTxop->GetAccessStatus(linkId) == Txop::NOT_REQUESTED &&
+                    qosTxop->HasFramesToTransmit(linkId))
+                {
+                    GetLink(linkId).channelAccessManager->RequestAccess(qosTxop);
+                }
+            });
+        }
+    }
+}
+
+void
 WifiMac::Enqueue(Ptr<Packet> packet, Mac48Address to, Mac48Address from)
 {
     // We expect WifiMac subclasses which do support forwarding (e.g.,
@@ -1124,6 +1240,12 @@
     {
         return;
     }
+
+    // Nothing to do with (QoS) Null Data frames
+    if (hdr->IsData() && !hdr->HasData())
+    {
+        return;
+    }
 
     if (hdr->IsMgt() && hdr->IsAction())
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-mac.h ns-3.39/src/wifi/model/wifi-mac.h
--- ns-3.38/src/wifi/model/wifi-mac.h	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-mac.h	2023-07-05 14:23:48.121428500 -0700
@@ -22,6 +22,7 @@
 
 #include "qos-utils.h"
 #include "ssid.h"
+#include "wifi-mac-queue-scheduler.h"
 #include "wifi-remote-station-manager.h"
 #include "wifi-standards.h"
 
@@ -50,12 +51,12 @@
 class FrameExchangeManager;
 class ChannelAccessManager;
 class ExtendedCapabilities;
-class WifiMacQueueScheduler;
 class OriginatorBlockAckAgreement;
 class RecipientBlockAckAgreement;
 
 /**
- * Enumeration for type of station
+ * \ingroup wifi
+ * Enumeration for type of WiFi station
  */
 enum TypeOfStation
 {
@@ -68,7 +69,6 @@
 
 /**
  * \ingroup wifi
- * \enum WifiMacDropReason
  * \brief The reason why an MPDU was dropped
  */
 enum WifiMacDropReason : uint8_t
@@ -203,6 +203,13 @@
     virtual Ptr<WifiMacQueue> GetTxopQueue(AcIndex ac) const;
 
     /**
+     * Check if the MAC has frames to transmit over the given link
+     * \param linkId the ID of the given link.
+     * \return whether the MAC has frames to transmit.
+     */
+    virtual bool HasFramesToTransmit(uint8_t linkId);
+
+    /**
      * Set the wifi MAC queue scheduler
      *
      * \param scheduler the wifi MAC queue scheduler
@@ -274,6 +281,32 @@
     void SetBssid(Mac48Address bssid, uint8_t linkId);
 
     /**
+     * Block the transmission on the given links of all unicast frames addressed to
+     * the station with the given address for the given reason. The given MAC address
+     * must be the MLD address in case the addressed device is multi-link.
+     *
+     * \param reason the reason for blocking transmissions
+     * \param address the MAC address of the given device
+     * \param linkIds the IDs of the links to block
+     */
+    void BlockUnicastTxOnLinks(WifiQueueBlockedReason reason,
+                               const Mac48Address& address,
+                               const std::set<uint8_t>& linkIds);
+
+    /**
+     * Unblock the transmission on the given links of all unicast frames addressed to
+     * the station with the given address for the given reason. The given MAC address
+     * must be the MLD address in case the addressed device is multi-link.
+     *
+     * \param reason the reason for unblocking transmissions
+     * \param address the MAC address of the given device
+     * \param linkIds the IDs of the links to unblock
+     */
+    void UnblockUnicastTxOnLinks(WifiQueueBlockedReason reason,
+                                 const Mac48Address& address,
+                                 const std::set<uint8_t>& linkIds);
+
+    /**
      * Return true if packets can be forwarded to the given destination,
      * false otherwise.
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-mac-header.cc ns-3.39/src/wifi/model/wifi-mac-header.cc
--- ns-3.38/src/wifi/model/wifi-mac-header.cc	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/wifi-mac-header.cc	2023-07-05 14:23:48.121428500 -0700
@@ -49,6 +49,7 @@
     SUBTYPE_CTL_CTLWRAPPER = 7,
     SUBTYPE_CTL_BACKREQ = 8,
     SUBTYPE_CTL_BACKRESP = 9,
+    SUBTYPE_CTL_PSPOLL = 10,
     SUBTYPE_CTL_RTS = 11,
     SUBTYPE_CTL_CTS = 12,
     SUBTYPE_CTL_ACK = 13,
@@ -59,6 +60,7 @@
 WifiMacHeader::WifiMacHeader()
     : m_ctrlMoreFrag(0),
       m_ctrlRetry(0),
+      m_ctrlPowerManagement(0),
       m_ctrlMoreData(0),
       m_ctrlWep(0),
       m_ctrlOrder(0),
@@ -150,6 +152,10 @@
         m_ctrlType = TYPE_CTL;
         m_ctrlSubtype = SUBTYPE_CTL_BACKRESP;
         break;
+    case WIFI_MAC_CTL_PSPOLL:
+        m_ctrlType = TYPE_CTL;
+        m_ctrlSubtype = SUBTYPE_CTL_PSPOLL;
+        break;
     case WIFI_MAC_CTL_RTS:
         m_ctrlType = TYPE_CTL;
         m_ctrlSubtype = SUBTYPE_CTL_RTS;
@@ -369,6 +375,18 @@
 }
 
 void
+WifiMacHeader::SetPowerManagement()
+{
+    m_ctrlPowerManagement = 1;
+}
+
+void
+WifiMacHeader::SetNoPowerManagement()
+{
+    m_ctrlPowerManagement = 0;
+}
+
+void
 WifiMacHeader::SetQosEosp()
 {
     m_qosEosp = 1;
@@ -510,6 +528,8 @@
             return WIFI_MAC_CTL_BACKREQ;
         case SUBTYPE_CTL_BACKRESP:
             return WIFI_MAC_CTL_BACKRESP;
+        case SUBTYPE_CTL_PSPOLL:
+            return WIFI_MAC_CTL_PSPOLL;
         case SUBTYPE_CTL_RTS:
             return WIFI_MAC_CTL_RTS;
         case SUBTYPE_CTL_CTS:
@@ -644,7 +664,6 @@
         return true;
     default:
         return false;
-        break;
     }
 }
 
@@ -680,6 +699,12 @@
 }
 
 bool
+WifiMacHeader::IsPsPoll() const
+{
+    return (GetType() == WIFI_MAC_CTL_PSPOLL);
+}
+
+bool
 WifiMacHeader::IsAck() const
 {
     return (GetType() == WIFI_MAC_CTL_ACK);
@@ -830,6 +855,12 @@
 }
 
 bool
+WifiMacHeader::IsPowerManagement() const
+{
+    return (m_ctrlPowerManagement == 1);
+}
+
+bool
 WifiMacHeader::IsQosBlockAck() const
 {
     NS_ASSERT(IsQosData());
@@ -914,6 +945,7 @@
     val |= (m_ctrlFromDs << 9) & (0x1 << 9);
     val |= (m_ctrlMoreFrag << 10) & (0x1 << 10);
     val |= (m_ctrlRetry << 11) & (0x1 << 11);
+    val |= (m_ctrlPowerManagement << 12) & (0x1 << 12);
     val |= (m_ctrlMoreData << 13) & (0x1 << 13);
     val |= (m_ctrlWep << 14) & (0x1 << 14);
     val |= (m_ctrlOrder << 15) & (0x1 << 15);
@@ -941,6 +973,7 @@
     m_ctrlFromDs = (ctrl >> 9) & 0x01;
     m_ctrlMoreFrag = (ctrl >> 10) & 0x01;
     m_ctrlRetry = (ctrl >> 11) & 0x01;
+    m_ctrlPowerManagement = (ctrl >> 12) & 0x01;
     m_ctrlMoreData = (ctrl >> 13) & 0x01;
     m_ctrlWep = (ctrl >> 14) & 0x01;
     m_ctrlOrder = (ctrl >> 15) & 0x01;
@@ -975,6 +1008,7 @@
     case TYPE_CTL:
         switch (m_ctrlSubtype)
         {
+        case SUBTYPE_CTL_PSPOLL:
         case SUBTYPE_CTL_RTS:
         case SUBTYPE_CTL_BACKREQ:
         case SUBTYPE_CTL_BACKRESP:
@@ -1010,55 +1044,55 @@
 const char*
 WifiMacHeader::GetTypeString() const
 {
-#define FOO(x)                                                                                     \
+#define CASE_WIFI_MAC_TYPE(x)                                                                      \
     case WIFI_MAC_##x:                                                                             \
-        return #x;                                                                                 \
-        break;
+        return #x;
 
     switch (GetType())
     {
-        FOO(CTL_RTS);
-        FOO(CTL_CTS);
-        FOO(CTL_ACK);
-        FOO(CTL_BACKREQ);
-        FOO(CTL_BACKRESP);
-        FOO(CTL_END);
-        FOO(CTL_END_ACK);
-        FOO(CTL_TRIGGER);
-
-        FOO(MGT_BEACON);
-        FOO(MGT_ASSOCIATION_REQUEST);
-        FOO(MGT_ASSOCIATION_RESPONSE);
-        FOO(MGT_DISASSOCIATION);
-        FOO(MGT_REASSOCIATION_REQUEST);
-        FOO(MGT_REASSOCIATION_RESPONSE);
-        FOO(MGT_PROBE_REQUEST);
-        FOO(MGT_PROBE_RESPONSE);
-        FOO(MGT_AUTHENTICATION);
-        FOO(MGT_DEAUTHENTICATION);
-        FOO(MGT_ACTION);
-        FOO(MGT_ACTION_NO_ACK);
-        FOO(MGT_MULTIHOP_ACTION);
-
-        FOO(DATA);
-        FOO(DATA_CFACK);
-        FOO(DATA_CFPOLL);
-        FOO(DATA_CFACK_CFPOLL);
-        FOO(DATA_NULL);
-        FOO(DATA_NULL_CFACK);
-        FOO(DATA_NULL_CFPOLL);
-        FOO(DATA_NULL_CFACK_CFPOLL);
-        FOO(QOSDATA);
-        FOO(QOSDATA_CFACK);
-        FOO(QOSDATA_CFPOLL);
-        FOO(QOSDATA_CFACK_CFPOLL);
-        FOO(QOSDATA_NULL);
-        FOO(QOSDATA_NULL_CFPOLL);
-        FOO(QOSDATA_NULL_CFACK_CFPOLL);
+        CASE_WIFI_MAC_TYPE(CTL_RTS);
+        CASE_WIFI_MAC_TYPE(CTL_CTS);
+        CASE_WIFI_MAC_TYPE(CTL_ACK);
+        CASE_WIFI_MAC_TYPE(CTL_BACKREQ);
+        CASE_WIFI_MAC_TYPE(CTL_BACKRESP);
+        CASE_WIFI_MAC_TYPE(CTL_END);
+        CASE_WIFI_MAC_TYPE(CTL_END_ACK);
+        CASE_WIFI_MAC_TYPE(CTL_PSPOLL);
+        CASE_WIFI_MAC_TYPE(CTL_TRIGGER);
+
+        CASE_WIFI_MAC_TYPE(MGT_BEACON);
+        CASE_WIFI_MAC_TYPE(MGT_ASSOCIATION_REQUEST);
+        CASE_WIFI_MAC_TYPE(MGT_ASSOCIATION_RESPONSE);
+        CASE_WIFI_MAC_TYPE(MGT_DISASSOCIATION);
+        CASE_WIFI_MAC_TYPE(MGT_REASSOCIATION_REQUEST);
+        CASE_WIFI_MAC_TYPE(MGT_REASSOCIATION_RESPONSE);
+        CASE_WIFI_MAC_TYPE(MGT_PROBE_REQUEST);
+        CASE_WIFI_MAC_TYPE(MGT_PROBE_RESPONSE);
+        CASE_WIFI_MAC_TYPE(MGT_AUTHENTICATION);
+        CASE_WIFI_MAC_TYPE(MGT_DEAUTHENTICATION);
+        CASE_WIFI_MAC_TYPE(MGT_ACTION);
+        CASE_WIFI_MAC_TYPE(MGT_ACTION_NO_ACK);
+        CASE_WIFI_MAC_TYPE(MGT_MULTIHOP_ACTION);
+
+        CASE_WIFI_MAC_TYPE(DATA);
+        CASE_WIFI_MAC_TYPE(DATA_CFACK);
+        CASE_WIFI_MAC_TYPE(DATA_CFPOLL);
+        CASE_WIFI_MAC_TYPE(DATA_CFACK_CFPOLL);
+        CASE_WIFI_MAC_TYPE(DATA_NULL);
+        CASE_WIFI_MAC_TYPE(DATA_NULL_CFACK);
+        CASE_WIFI_MAC_TYPE(DATA_NULL_CFPOLL);
+        CASE_WIFI_MAC_TYPE(DATA_NULL_CFACK_CFPOLL);
+        CASE_WIFI_MAC_TYPE(QOSDATA);
+        CASE_WIFI_MAC_TYPE(QOSDATA_CFACK);
+        CASE_WIFI_MAC_TYPE(QOSDATA_CFPOLL);
+        CASE_WIFI_MAC_TYPE(QOSDATA_CFACK_CFPOLL);
+        CASE_WIFI_MAC_TYPE(QOSDATA_NULL);
+        CASE_WIFI_MAC_TYPE(QOSDATA_NULL_CFPOLL);
+        CASE_WIFI_MAC_TYPE(QOSDATA_NULL_CFACK_CFPOLL);
     default:
         return "ERROR";
     }
-#undef FOO
+#undef CASE_WIFI_MAC_TYPE
 #ifndef _WIN32
     // needed to make gcc 4.0.1 ppc darwin happy.
     return "BIG_ERROR";
@@ -1084,9 +1118,12 @@
 void
 WifiMacHeader::PrintFrameControl(std::ostream& os) const
 {
-    os << "ToDS=" << std::hex << (int)m_ctrlToDs << ", FromDS=" << std::hex << (int)m_ctrlFromDs
-       << ", MoreFrag=" << std::hex << (int)m_ctrlMoreFrag << ", Retry=" << std::hex
-       << (int)m_ctrlRetry << ", MoreData=" << std::hex << (int)m_ctrlMoreData << std::dec;
+    os << "ToDS=" << std::hex << static_cast<int>(m_ctrlToDs)
+       << ", FromDS=" << static_cast<int>(m_ctrlFromDs)
+       << ", MoreFrag=" << static_cast<int>(m_ctrlMoreFrag)
+       << ", Retry=" << static_cast<int>(m_ctrlRetry)
+       << ", PowerManagement=" << static_cast<int>(m_ctrlPowerManagement)
+       << ", MoreData=" << static_cast<int>(m_ctrlMoreData) << std::dec;
 }
 
 void
@@ -1095,6 +1132,10 @@
     os << GetTypeString() << " ";
     switch (GetType())
     {
+    case WIFI_MAC_CTL_PSPOLL:
+        os << "Duration/ID=" << std::hex << m_duration << std::dec << ", BSSID(RA)=" << m_addr1
+           << ", TA=" << m_addr2;
+        break;
     case WIFI_MAC_CTL_RTS:
     case WIFI_MAC_CTL_TRIGGER:
         os << "Duration/ID=" << m_duration << "us"
@@ -1208,6 +1249,7 @@
     case TYPE_CTL:
         switch (m_ctrlSubtype)
         {
+        case SUBTYPE_CTL_PSPOLL:
         case SUBTYPE_CTL_RTS:
         case SUBTYPE_CTL_TRIGGER:
         case SUBTYPE_CTL_BACKREQ:
@@ -1264,6 +1306,7 @@
     case TYPE_CTL:
         switch (m_ctrlSubtype)
         {
+        case SUBTYPE_CTL_PSPOLL:
         case SUBTYPE_CTL_RTS:
         case SUBTYPE_CTL_TRIGGER:
         case SUBTYPE_CTL_BACKREQ:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-mac-header.h ns-3.39/src/wifi/model/wifi-mac-header.h
--- ns-3.38/src/wifi/model/wifi-mac-header.h	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/wifi-mac-header.h	2023-07-05 14:23:48.121428500 -0700
@@ -37,6 +37,7 @@
 {
     WIFI_MAC_CTL_TRIGGER = 0,
     WIFI_MAC_CTL_CTLWRAPPER,
+    WIFI_MAC_CTL_PSPOLL,
     WIFI_MAC_CTL_RTS,
     WIFI_MAC_CTL_CTS,
     WIFI_MAC_CTL_ACK,
@@ -236,6 +237,14 @@
      */
     void SetNoRetry();
     /**
+     * Set the Power Management bit in the Frame Control field.
+     */
+    void SetPowerManagement();
+    /**
+     * Un-set the Power Management bit in the Frame Control field.
+     */
+    void SetNoPowerManagement();
+    /**
      * Set the TID for the QoS header.
      *
      * \param tid the TID for the QoS header
@@ -317,9 +326,9 @@
      */
     Mac48Address GetAddr4() const;
     /**
-     * Return the type (enum WifiMacType)
+     * Return the type (WifiMacType)
      *
-     * \return the type (enum WifiMacType)
+     * \return the type (WifiMacType)
      */
     WifiMacType GetType() const;
     /**
@@ -383,6 +392,12 @@
      */
     bool IsCfEnd() const;
     /**
+     * Return true if the header is a PS-POLL header.
+     *
+     * \return true if the header is a PS-POLL header, false otherwise
+     */
+    bool IsPsPoll() const;
+    /**
      * Return true if the header is a RTS header.
      *
      * \return true if the header is a RTS header, false otherwise
@@ -534,6 +549,12 @@
      */
     bool IsRetry() const;
     /**
+     * Return if the Power Management bit is set.
+     *
+     * \return true if the Power Management bit is set, false otherwise
+     */
+    bool IsPowerManagement() const;
+    /**
      * Return if the More Data bit is set.
      *
      * \return true if the More Data bit is set, false otherwise
@@ -653,14 +674,15 @@
      */
     void PrintFrameControl(std::ostream& os) const;
 
-    uint8_t m_ctrlType;     ///< control type
-    uint8_t m_ctrlSubtype;  ///< control subtype
-    uint8_t m_ctrlToDs;     ///< control to DS
-    uint8_t m_ctrlFromDs;   ///< control from DS
-    uint8_t m_ctrlMoreFrag; ///< control more fragments
-    uint8_t m_ctrlRetry;    ///< control retry
-    uint8_t m_ctrlMoreData; ///< control more data
-    uint8_t m_ctrlWep;      ///< control WEP
+    uint8_t m_ctrlType;            ///< control type
+    uint8_t m_ctrlSubtype;         ///< control subtype
+    uint8_t m_ctrlToDs;            ///< control to DS
+    uint8_t m_ctrlFromDs;          ///< control from DS
+    uint8_t m_ctrlMoreFrag;        ///< control more fragments
+    uint8_t m_ctrlRetry;           ///< control retry
+    uint8_t m_ctrlPowerManagement; ///< control power management
+    uint8_t m_ctrlMoreData;        ///< control more data
+    uint8_t m_ctrlWep;             ///< control WEP
     uint8_t m_ctrlOrder;  ///< control order (set to 1 for QoS Data and Management frames to signify
                           ///< that HT/VHT/HE control field is present, knowing that the latter are
                           ///< not implemented yet)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-mac-queue.cc ns-3.39/src/wifi/model/wifi-mac-queue.cc
--- ns-3.38/src/wifi/model/wifi-mac-queue.cc	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-mac-queue.cc	2023-07-05 14:23:48.121428500 -0700
@@ -22,12 +22,12 @@
 
 #include "wifi-mac-queue.h"
 
-#include "qos-blocked-destinations.h"
 #include "wifi-mac-queue-scheduler.h"
 
 #include "ns3/simulator.h"
 
 #include <functional>
+#include <optional>
 
 namespace ns3
 {
@@ -100,6 +100,21 @@
     return GetIt(mpdu)->mpdu;
 }
 
+Ptr<WifiMpdu>
+WifiMacQueue::GetAlias(Ptr<const WifiMpdu> mpdu, uint8_t linkId)
+{
+    if (!mpdu->IsQueued())
+    {
+        return nullptr;
+    }
+    if (auto aliasIt = GetIt(mpdu)->inflights.find(linkId);
+        aliasIt != GetIt(mpdu)->inflights.cend())
+    {
+        return aliasIt->second;
+    }
+    return nullptr;
+}
+
 void
 WifiMacQueue::ExtractExpiredMpdus(const WifiContainerQueueId& queueId) const
 {
@@ -303,7 +318,7 @@
 {
     NS_LOG_FUNCTION(this << +tid << dest << item);
     NS_ABORT_IF(dest.IsGroup());
-    WifiContainerQueueId queueId(WIFI_QOSDATA_UNICAST_QUEUE, dest, tid);
+    WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, dest, tid);
     return PeekByQueueId(queueId, item);
 }
 
@@ -331,18 +346,13 @@
 }
 
 Ptr<WifiMpdu>
-WifiMacQueue::PeekFirstAvailable(uint8_t linkId,
-                                 const Ptr<QosBlockedDestinations> blockedPackets,
-                                 Ptr<const WifiMpdu> item) const
+WifiMacQueue::PeekFirstAvailable(uint8_t linkId, Ptr<const WifiMpdu> item) const
 {
     NS_LOG_FUNCTION(this << +linkId << item);
     NS_ASSERT(!item || item->IsQueued());
 
     if (item)
     {
-        NS_ASSERT(!item->GetHeader().IsQosData() || !blockedPackets ||
-                  !blockedPackets->IsBlocked(item->GetHeader().GetAddr1(),
-                                             item->GetHeader().GetQosTid()));
         // check if there are other MPDUs in the same container queue as item
         auto mpdu = PeekByQueueId(WifiMacQueueContainer::GetQueueId(item), item);
 
@@ -363,19 +373,6 @@
         queueId = m_scheduler->GetNext(m_ac, linkId);
     }
 
-    NS_ASSERT(!queueId || std::get<0>(*queueId) != WIFI_QOSDATA_UNICAST_QUEUE ||
-              std::get<2>(*queueId));
-
-    while (queueId.has_value() && blockedPackets &&
-           std::get<0>(queueId.value()) == WIFI_QOSDATA_UNICAST_QUEUE &&
-           blockedPackets->IsBlocked(std::get<1>(queueId.value()), *std::get<2>(queueId.value())))
-    {
-        queueId = m_scheduler->GetNext(m_ac, linkId, queueId.value());
-
-        NS_ASSERT(!queueId || std::get<0>(*queueId) != WIFI_QOSDATA_UNICAST_QUEUE ||
-                  std::get<2>(*queueId));
-    }
-
     if (!queueId.has_value())
     {
         NS_LOG_DEBUG("The queue is empty");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-mac-queue-container.cc ns-3.39/src/wifi/model/wifi-mac-queue-container.cc
--- ns-3.38/src/wifi/model/wifi-mac-queue-container.cc	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/wifi-mac-queue-container.cc	2023-07-05 14:23:48.121428500 -0700
@@ -79,23 +79,22 @@
 {
     const WifiMacHeader& hdr = mpdu->GetHeader();
 
+    auto addrType = hdr.GetAddr1().IsGroup() ? WIFI_BROADCAST : WIFI_UNICAST;
+    auto address = hdr.GetAddr1().IsGroup() ? hdr.GetAddr2() : hdr.GetAddr1();
+
     if (hdr.IsCtl())
     {
-        return {WIFI_CTL_QUEUE, hdr.GetAddr2(), std::nullopt};
+        return {WIFI_CTL_QUEUE, addrType, address, std::nullopt};
     }
     if (hdr.IsMgt())
     {
-        return {WIFI_MGT_QUEUE, hdr.GetAddr2(), std::nullopt};
+        return {WIFI_MGT_QUEUE, addrType, address, std::nullopt};
     }
     if (hdr.IsQosData())
     {
-        if (hdr.GetAddr1().IsGroup())
-        {
-            return {WIFI_QOSDATA_BROADCAST_QUEUE, hdr.GetAddr2(), hdr.GetQosTid()};
-        }
-        return {WIFI_QOSDATA_UNICAST_QUEUE, hdr.GetAddr1(), hdr.GetQosTid()};
+        return {WIFI_QOSDATA_QUEUE, addrType, address, hdr.GetQosTid()};
     }
-    return {WIFI_DATA_QUEUE, hdr.GetAddr1(), std::nullopt};
+    return {WIFI_DATA_QUEUE, addrType, address, std::nullopt};
 }
 
 const WifiMacQueueContainer::ContainerQueue&
@@ -207,7 +206,7 @@
 std::size_t
 std::hash<ns3::WifiContainerQueueId>::operator()(ns3::WifiContainerQueueId queueId) const
 {
-    auto [type, address, tid] = queueId;
+    auto [type, addrType, address, tid] = queueId;
     const std::size_t size = tid.has_value() ? 8 : 7;
 
     uint8_t buffer[size];
